Attribute VB_Name = "ObjectArrays"
Option Explicit

'    _____________________________     '
'   |                             |    '
'   |  Object Array Field         |    '
'   |   Subrountines             /     '
'   |___________________________/      '
'                                      '
'
'          Created By Diederik van der Boor



' Use these functions when you're making "gridgames".
' (Like minesweeper / Four in a Row)




' Functions for converting a Object Index number
' into  X Y positions (used by a Matrix)
' The XrowSize tells the functions how much objects there are in ONE ROW of the
' Control Array field (Created by the DrawField sub).
Public Function getObjArrayIndex(X As Integer, Y As Integer, XrowSize As Integer) As Integer
  getObjArrayIndex = X + (Y * XrowSize) + 1
End Function

Public Function getXfromObjArray(Index As Integer, maxXrow As Integer) As Integer
  getXfromObjArray = (Index - 1) Mod maxXrow
End Function

Public Function getYfromObjArray(Index As Integer, maxXrow As Integer) As Integer
  getYfromObjArray = (Index - 1) \ maxXrow
End Function



' This sub creates a object-array field, using the first index (0) as prototype for the field objects
' The 1st field item contains index number 1 (and will be positioned above the prototype object).
'
' You can use the getYfromObjArray / getYfromObjArray / getObjArrayIndex - functions
' if you want to find out which X-Y position the Array Index number stands for.
' These positions can be useful for a martix (Easier to test 4 in a row etc..)

Public Sub DrawField(ObjPrototype As Object, sizeX As Integer, sizeY As Integer, Optional hSpace As Integer, Optional vSpace As Integer)
  Dim I As Integer
  Dim posLeft As Long: posLeft = ObjPrototype(0).Left
  Dim posTop As Long:  posTop = ObjPrototype(0).Top
  ObjPrototype(0).ZOrder vbSendToBack
  
  For I = 1 To sizeX * sizeY
    Load ObjPrototype(I)
    ObjPrototype(I).Left = posLeft
    ObjPrototype(I).Top = posTop
    ObjPrototype(I).Visible = True
    ObjPrototype(I).ZOrder vbBringToFront
    If I Mod sizeX = 0 Then
      posLeft = ObjPrototype(0).Left
      posTop = ObjPrototype(I).Top + ObjPrototype(0).Height + vSpace
    Else
      posLeft = posLeft + ObjPrototype(I).Width + hSpace
    End If
  Next
End Sub

' And a DestroyField sub

Public Sub DestroyField(ObjPrototype As Object)
  Dim I As Integer
  For I = ObjPrototype.Count - 1 To 1 Step -1
    Unload ObjPrototype(I)
  Next
  ObjPrototype(0).Visible = False
End Sub

