Attribute VB_Name = "Declares"
Option Explicit


'----------------------------------------------------------------
' Object constants used in the level array

Public Const SPACE As Byte = 0
Public Const TARGET As Byte = 1
Public Const BOX As Byte = 2         ' BOXATTARGET BitAnd BitNot BOX = TARGET
Public Const BOXATTARGET As Byte = 3 ' TARGET BitOr BOX = BOXATTARGET
Public Const WALL As Byte = 4
Public Const VOID As Byte = 255

Public Const OBJECT_IMAGES As Byte = 5
Public Const PLAYER As Byte = OBJECT_IMAGES ' Special: Last one


'----------------------------------------------------------------
' Player animation frames

Public Const STANDLEFT As Byte = 0
Public Const JOY1 As Byte = 1
Public Const JOY2 As Byte = 2
Public Const WALKLEFT As Byte = 3
Public Const WALKRIGHT As Byte = 4
Public Const STANDRIGHT As Byte = 5
Public Const PUSHLEFT As Byte = 6
Public Const PUSHRIGHT As Byte = 7
Public Const PLAYER_IMAGES As Byte = 8


'----------------------------------------------------------------
' Misc constant settings

Public Const PIXEL = 15 ' ScaleMode: Twips to Pixels
Public Const OBJECT_SIZE = 32
Public Const ID_SIZE = 7


'----------------------------------------------------------------
' Sleep time for animation

Public Const SLEEP_TIME = 15
Public Const SLEEP_MOVEBOX = 100
Public Const SLEEP_LONGTIME = 200

Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)


'----------------------------------------------------------------
' Constants used for readability of the code

Public Const MODE_PLAY As Byte = 0
Public Const MODE_PLAYTEST As Byte = 1
Public Const MODE_EDIT As Byte = 2

Public Const PLAY_THIS As Integer = 0
Public Const PLAY_NONE As Integer = 1

Public Const SAVE_NORMAL As Integer = 0
Public Const SAVE_AS As Integer = 1

'----------------------------------------------------------------
' ID in level files

Public Const PROGRAM_ID As String * ID_SIZE = "CARRIER"

'----------------------------------------------------------------


'----------------------------------------------------------------
' Global Variables...

Public DATAPATH As String
Public Game As GAMEDATA
Public ActiveForm As Form
Public InAnimation As Boolean


'----------------------------------------------------------------
' Structures used for storing all the game information

Public Type LOCATION
  X As Integer
  Y As Integer
End Type

Public Type LEVEL
  Name As String
  OtherInfo As String
  PLAYER As LOCATION
  Width As Integer
  Height As Integer
  Fields() As Byte
End Type

Public Type UNDOSTEP
  PlayerPos As LOCATION
  NextPos As LOCATION
  NextValue As Byte
  NextAfterPos As LOCATION
  NextAfterValue As Byte
  PlayerStyle As Byte
End Type

Public Type LEVELFILE
  ID As String * ID_SIZE
  VersionMajor As Integer
  VersionMinor As Integer
  VersionRevision As Integer
  Contents As LEVEL
End Type

Public Type GAMEDATA
  StepsDone As Integer
  PrevStep As Integer
  Undo(0 To 0) As UNDOSTEP
  PlayerStyle As Byte
  PlayedLevel As LEVEL
  OriginalLevel As LEVEL
  Complete As Boolean
  FileName As String
  Mode As Byte
  UndoAvailable As Boolean
  Object(0 To OBJECT_IMAGES - 1) As StdPicture
  PLAYER(0 To PLAYER_IMAGES - 1) As StdPicture
End Type
